#!/usr/local/bin/perl
#
# postfix-module by Guillaume Cottenceau <gc@mandrakesoft.com>,
# for webmin by Jamie Cameron
#
# Copyright (c) 2000 by Mandrakesoft
#
# Permission to use, copy, modify, and distribute this software and its
# documentation under the terms of the GNU General Public License is hereby 
# granted. No representations are made about the suitability of this software 
# for any purpose. It is provided "as is" without express or implied warranty.
# See the GNU General Public License for more details.
#
# 
# Edit a mapping

require './postfix-lib.pl';
&ReadParse();

&ui_print_header(undef, $text{'edit_map_title'}, "");

my $new_one = 0;
my $num;
## added to split main_parameter:sub_parameter
my ($mainparm,$subparm)=split /:/,$in{'map_name'};

if (!exists($in{'num'}))
{
    $num = &init_new_mapping($in{'map_name'});
    $new_one = 1;
}
else
{
    $num = $in{'num'};
}

my $maps = &get_maps($in{'map_name'});
my %map;

foreach $trans (@{$maps})
{
    if ($trans->{'number'} == $num) { %map = %{$trans}; }
}    

print "<form action=save_map.cgi>\n";
print "<input type=hidden name=\"num\" value=\"$num\">";
print "<input type=hidden name=\"map_name\" value=\"$in{'map_name'}\">";

print "<table border width=100%>\n";
print "<tr $tb> <td><b>$text{'edit_map_title'}</b></td></tr>\n";
print "<tr $cb> <td><table>\n";

##$nfunc = "edit_name_".$in{'map_name'};
## modified to capture subparameters
$nfunc="edit_name_"; $nfunc.=($subparm)? $subparm : $mainparm;
print "<tr>\n";
if (defined(&$nfunc)) {
	print &$nfunc(\%map);
	}
else {
	print "<td><b>$text{'mapping_name'}</b></td> <td nowrap>\n";
	print "<input name=\"name\" size=40 value=\"$map{'name'}\"> </td>\n";
	}
print "</tr>\n";


##$vfunc = "edit_value_".$in{'map_name'};
## modified to capture subparameters
$vfunc="edit_value_"; $vfunc.=($subparm)? $subparm : $mainparm;
print "<tr>\n";
if (defined(&$vfunc)) {
	print &$vfunc(\%map);
	}
else {
	print "<td><b>$text{'mapping_value'}</b></td> <td nowrap>\n";
	print "<input name=\"value\" size=40 value=\"$map{'value'}\"> </td>\n";
	}
print "</tr>\n";

print "</table></td></tr></table><p>\n";
print "<input type=submit value=\"$text{'map_save'}\">\n";
$new_one || print "<input type=submit name=delete value=\"$text{'delete_map'}\">";
print "</form>\n";

if ($in{'map_name'} eq $virtual_maps) {
	&ui_print_footer("virtual.cgi", $text{'virtual_return'});
	}
elsif ($in{'map_name'} eq 'canonical_maps') {
	&ui_print_footer($ENV{'HTTP_REFERER'},
			 $text{'canonical_return'});
	}
elsif ($in{'map_name'} eq 'sender_canonical_maps') {
	&ui_print_footer($ENV{'HTTP_REFERER'},
			 $text{'canonical_return_sender'});
	}
elsif ($in{'map_name'} eq 'recipient_canonical_maps') {
	&ui_print_footer($ENV{'HTTP_REFERER'},
			 $text{'canonical_return_recipient'});
	}
elsif ($in{'map_name'} eq 'transport_maps') {
	&ui_print_footer("transport.cgi", $text{'transport_return'});
	}
elsif ($in{'map_name'} eq 'relocated_maps') {
	&ui_print_footer("relocated.cgi", $text{'relocated_return'});
	}
elsif ($in{'map_name'} eq 'header_checks') {
	&ui_print_footer("header.cgi", $text{'header_return'});
	}
elsif ($in{'map_name'} eq 'body_checks') {
	&ui_print_footer("body.cgi", $text{'body_return'});
	}
else {
	&ui_print_footer("", $text{'index_return'});
	}

