#!/usr/local/bin/perl
# list_mailers.cgi
# Display a list of mailertable domains

require './sendmail-lib.pl';
require './mailers-lib.pl';

$access{'mailers'} || &error($text{'mailers_cannot'});
&ui_print_header(undef, $text{'mailers_title'}, "");

$conf = &get_sendmailcf();
$mfile = &mailers_file($conf);
($mdbm, $mdbmtype) = &mailers_dbm($conf);
if (!$mdbm) {
	# No Kmailertable directive in sendmail.cf
	print "<b>",&text('mailers_efeature', 'list_features.cgi'),"</b><p>\n";
	&ui_print_footer("", $text{'index_return'});
	exit;
	}
if (!-r $mfile) {
	# Text file not found
	print "<b>",&text('mailers_efile', "<tt>$mfile</tt>",
	      "<tt>$mdbm</tt>", "$gconfig{'webprefix'}/config.cgi?$module_name"),"</b> <p>\n";
	print "<b>",&text('virtusers_createfile',
		    	  'create_file.cgi?mode=mailers'),"</b><p>\n";
	&ui_print_footer("", $text{'index_return'});
	exit;
	}
@mailers = &list_mailers($mfile);

&mailer_form();
if (@mailers) {
	# sort if needed
	if ($config{'sort_mode'} == 1) {
		@mailers = sort { $a->{'domain'} cmp $b->{'domain'} } @mailers;
		}

	# render table of mailers
	print &ui_form_start("delete_mailers.cgi", "post");
	print &select_all_link("d", 1),"\n";
	print &select_invert_link("d", 1),"<br>\n";
	if ($config{'columns'} == 2) {
		$mid = int((@mailers+1)/2);
		print "<table width=100%> <tr><td width=50% valign=top>\n";
		&mailers_table(@mailers[0..$mid-1]);
		print "</td><td width=50% valign=top>\n";
		if ($mid < @mailers) { &mailers_table(@mailers[$mid..$#mailers]); }
		print "</td></tr> </table><br>\n";
		}
	else {
		&mailers_table(@mailers);
		}
	print &select_all_link("d", 1),"\n";
	print &select_invert_link("d", 1),"<br>\n";
	print &ui_form_end([ [ "delete", $text{'mailers_delete'} ] ]);
	}
print "<a href='edit_file.cgi?mode=mailers'>",
	&text('file_edit', "<tt>$mfile</tt>"),"</a><p>\n"
	if ($access{'manual'});
print $text{'mailers_desc1'},"<p>\n";
print &text('mailers_desc2', 'list_cws.cgi')," ",
      &text('mailers_desc3', 'list_relay.cgi'),"<br>\n";

&ui_print_footer("", $text{'index_return'});

sub mailers_table
{
print "<table border width=100%>\n";
print "<tr $tb> <td width=5><br></td> <td><b>$text{'mailers_for'}</b></td> ",
      "<td><b>$text{'mailers_delivery'}</b></td> ",
      "<td><b>$text{'mailers_to'}</b></td> </tr>\n";
foreach $m (@_) {
	print "<tr $cb>\n";
	print "<td width=5>",&ui_checkbox("d", $m->{'domain'}),"</td>\n";
	print "<td><a href=\"edit_mailer.cgi?num=$m->{'num'}\">",
	      &html_escape($m->{'domain'}),"</a></td>\n";
	$md = $mailer_desc{$m->{'mailer'}};
	print "<td>",$md ? $md : $m->{'mailer'},"</td>\n";
	print "<td>",&html_escape($m->{'dest'}),"</td> </tr>\n";
	}
print "</table>\n";
}

